#include "fitness.hpp"

#include <array>

double calculate_fitness(const std::string& text)
{
    int total = 0;
    std::array<double, 26> counts;
    counts.fill(0.0);
    for (auto letter : text)
    {
        int letterCode = letter - 'A';
        if (letterCode < 0 || letterCode > 25)
            continue;

        counts[letterCode]++;
        total++;
    }

    // std::cout << "Frequencies :" << std::endl;

    double sum = 0;
    char index = 'A';
    for (double count : counts)
    {
        // std::cout << "Count of " << index << ":" << count << std::endl;
        sum += count * (count - 1);
        index++;
    }
    return sum / (total * (total - 1));
}
